#ifndef __csplitter_inc__
#define __csplitter_inc__

#ifndef __windows_inc__
#include "windows.inc"
#endif

// splitter window style: where to attach
#define SPLITERSTYLE_LEFT   0x1
#define SPLITERSTYLE_TOP    0x2
#define SPLITERSTYLE_RIGHT  0x4
#define SPLITERSTYLE_BOTTOM 0x8
//private
#define SPLITERSTYLE_MASK   0xF
#define SPLITERSTYLE_HORIZONTAL 0x10
#define SPLITERSTYLE_VERTICAL   0x20

#define DEFAULT_SPLITTER_WND_STYLE (AWS_CHILD | AWS_VISIBLE | AWS_BORDER)


class CSpliter : CWindow
{
	declare  CSpliter();
	declare _CSpliter();
	
	// Create method uses l,w,h,parent and style, where style = one of SPLITERSTYLE_*
	// w - width of the splitter (valid if style is 'left' or 'right')
	// h - height of the splitter (valid if style is 'top' or 'bottom')
	declare virtual Create(int l,int t,int w,int h,int style,int exstyle,string title,CWindow *parent),int;
	declare virtual OnSize(int nType,int cx,int cy),int;
	// XOR the dotted line on screen
	declare virtual DrawSplitter();
	// on drag end this method resizes window C
	declare virtual ResizeNextChild();

	declare virtual OnLButtonDown(int x,int y, int flags),int;
	declare virtual OnMouseMove(int x,int y,int flags),int;
	declare virtual OnLButtonUp(int x,int y,int flags),int;

	// m_hwndClip: window handle where drag-drop is alloved.
	// default: parent of parent window of the splitter window (window A)
	HWND     m_hwndClip; 
	int      m_style;
	HBRUSH   m_hbr;        // do not change! m_hbr, m_hbm, m_ptClientsize
	HBITMAP  m_hbm;
	POINT    m_ptClientsize;// size of (B)
	POINT    m_ptSplstart; // where in the splitter window the mouse was down
	POINT    m_ptSplpos;   // current cursor position while dragging
	POINT    m_ptClientPos;// updated in OnSize
	HCURSOR  m_crsSize;
	HWND     m_hwndParent; // B
	HWND     m_hwndNotifySizeChanged; // window C
	int      m_splitterW; // updated in OnSize
	int      m_splitterH;
	POINT    m_ptDrawSplitterOffset; // {-1,-1} fine positioning of drag-dotted line
}

#endif
